#ifndef _IGL_intern_H  // IGL_intern.h nicht doppelt benutzen
#define _IGL_intern_H

#include "IGL.h"
#include "queue"
#include "iostream"


#ifdef DEBUG
  #define IGL_DEBUG(x) cout << x
#else 
  #define IGL_DEBUG(x) 
#endif


namespace IGL {

using namespace std;
  // ===== Default-Werte und Konstanten =====
  static const char  DfltName[]      = "IGL";
  static const float DfltBackCol[]   = { IGL_Dflt_Back },
                     DfltColor[4]    = { IGL_Blue, 1.0 },
                     DfltLightPos[4] = { 0.3, 0.3, 1.0, 0.0 },
                     DfltAxis[6]     = { -1.0, 1.0, -1.0, 1.0, -1.0, 1.0 };
  static const int   Timeout=20000;

  enum MessType   { Store, Exec, KillLoop, Send };
  enum CmdWinType { Opn = 0, Cls = 1, Clr = 2,  Res = 3, Rdp = 4};
  enum CmdSetType { SPntS, SMarkS, SLineW, SAxis, SWMod, SDMod, Col, BCol, WNam };
  enum CmdObjType { Pnt, Line, TriFlat, Tri, Rect, Quad };

  // ===== verwendete Klassen =====
  class IGLoop;
  class IGLCmd;
  class CmdWin;
  class CmdSetProp;
  class CmdObj;

  // Die Kommando-Queue  und die Zeichen-Queue sind Teil einer jeden 
  // BaseWin-Instanz. 

  // Die cmdQueue wird in der Timer-Funktion BaseWin::issueWindowCmds 
  // abgearbeitet
  typedef queue<CmdWin*>    CmdQueueCL;

  // Die drawQueue wird bei einem Redraw von der Methode BaseWin::display() 
  // durchgearbeitet
  typedef queue<IGLCmd*>    DrawQueueCL;
};

using namespace IGL;


class Error
{
 public:
  char *ErrText;
  Error ( const char Text[] );
};

static void IGLWarn ( const char Text[] )
{
  cerr << "IGL Warning: " << Text << endl;
}


#endif
